##### GENERAL STUFF #####

%define name	libgphoto
%define version	2.4.0
%define release	%mkrel 4

%define major		2
%define libname		%mklibname gphoto %{major}
%define develname	%mklibname gphoto -d

# Enable debug mode
%define debug 0

%define extraversion %nil

Summary:	Library to access digital cameras
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	LGPL+ and GPLv2 and (LGPL+ or BSD-like)
Group:		Graphics


##### SOURCE FILES #####

Source0: 	http://heanet.dl.sourceforge.net/sourceforge/gphoto/%{name}%{major}-%{version}%{?extraversion:%extraversion}.tar.bz2
# Taken from the old patch2: do it as a source now as we don't want to
# use any part of the upstream file any more
Source1:	usbcam_agent

##### PATCHES #####

# Remove signatures for Pentax Optio 450
Patch10: libgphoto2-2.4.0-pentax.patch
# (fc) 2.4.0-5mdv don't reset USB bus for Canon cameras (SVN) (Mdv bug #35642)
Patch11: libgphoto2-2.4.0-fixcanon.patch

##### ADDITIONAL DEFINITIONS #####

Url: http://sourceforge.net/projects/gphoto/
BuildRoot: %{_tmppath}/%{name}-buildroot
Obsoletes:	hackgphoto2
Provides:	hackgphoto2
Conflicts:	gphoto2 <= 2.1.0
BuildRequires:	glib-devel libusb-devel >= 0.1.6 zlib-devel findutils perl
BuildRequires:	libexif-devel
BuildRequires:	udev-tools
BuildRequires:	libltdl-devel libhal-devel >= 0.5 libjpeg-devel



##### SUB-PACKAGES #####

%description
The gPhoto2 project is a universal, free application and library
framework that lets you download images from several different
digital camera models, including the newer models with USB
connections. Note that
a) for some older camera models you must use the old "gphoto" package.
b) for USB mass storage models you must use the driver in the kernel

This package contains the library that digital camera applications
can use.

Frontends (GUI and command line) are available separately.

%package -n %{libname}
Summary:	Library to access to digital cameras
Requires: 	libusb >= 0.1.5
Requires:	%{name}-common >= 2.2.1-7mdv2007.0
Provides:	%{name} = %{version}-%{release}
Conflicts:	gphoto2 <= 2.1.0
Conflicts:	%{libname}-devel < 2.2.1-9mdv2007.0
Group:		Graphics

%description -n %{libname}
This library contains all the functionality to access to modern digital
cameras via USB or the serial port.

%package common
Summary:	Platform-independent files for the "%{libname}" library
Group:		Graphics
Conflicts:	%{libname} <= 2.2.1-6mdv2007.0

%description common
Platform-independent files for the "%{libname}" library

%package -n %{develname}
Summary:	Headers and links to compile against the "%{libname}" library
Requires: 	%{libname} >= %{version}
Requires:	libexif-devel
Requires:	multiarch-utils
Requires:	libusb-devel >= 0.1.11
Provides:	%{name}-devel = %{version}-%{release}
Provides:	gphoto%{major}-devel = %{version}-%{release}
Conflicts:	gphoto2 <= 2.1.0
Obsoletes:	%{mklibname gphoto 2 -d}
Group:		Development/C

%description -n %{develname}
This package contains all files which one needs to compile programs using
the "%{libname}" library.

%package hotplug
Summary:	Hotplug support from libgphoto
Group:		System/Configuration/Hardware
Requires:	udev

%description hotplug
This package contains the scripts necessary for hotplug support.



##### PREP #####

%prep

%setup -q -n %{name}%{major}-%{version}%{?extraversion:%extraversion}

%patch10 -p1 -b .pentax
%patch11 -p1 -b .fixcanon

##### BUILD #####

%build

%if %debug
export DONT_STRIP=1
CFLAGS="`echo %optflags |sed -e 's/-O3/-g/'`" CXXFLAGS="`echo %optflags |sed -e 's/-O3/-g/'`"
%endif
%configure2_5x --disable-rpath --with-doc-dir=%{_docdir}/%{libname}

%make

##### INSTALL #####

%install
rm -rf ${RPM_BUILD_ROOT}

%if %debug
export DONT_STRIP=1
%endif

%makeinstall_std

# Fix up libtool libraries.
find $RPM_BUILD_ROOT -name '*.la' | \
	xargs perl -p -i -e "s|$RPM_BUILD_ROOT||g"

# we should move that into the proper Makefile.am eventually
install -d -m755 %{buildroot}/etc/udev/agents.d/usb
install -m755 %{SOURCE1} %{buildroot}/etc/udev/agents.d/usb/usbcam

# Create HAL FDI file
install -d -m755 %{buildroot}/usr/share/hal/fdi/information/20thirdparty/
	export LIBDIR=%{buildroot}%{_libdir}
	export CAMLIBS=%{buildroot}%{_libdir}/libgphoto2/2.4.0
	export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
	%{buildroot}%{_libdir}/libgphoto2/print-camera-list hal-fdi | \
	grep -v "<!-- This file was generated" \
	> %{buildroot}/%{_datadir}/hal/fdi/information/20thirdparty/10-camera-libgphoto2.fdi

# Create udev rules file
install -d -m755 %{buildroot}/etc/udev/rules.d/
	export LIBDIR=%{buildroot}%{_libdir}
	export CAMLIBS=%{buildroot}%{_libdir}/libgphoto2/2.4.0
	export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
	%{buildroot}%{_libdir}/libgphoto2/print-camera-list udev-rules mode 0660 \
	> %{buildroot}/etc/udev/rules.d/90-libgphoto2.rules

%find_lang libgphoto2-2
%find_lang libgphoto2_port-0
cat libgphoto2-2.lang libgphoto2_port-0.lang > %{name}.lang

# Multiarch setup
%multiarch_binaries %buildroot%{_bindir}/gphoto2-config
%multiarch_binaries %buildroot%{_bindir}/gphoto2-port-config

# Don't need to package this
rm -f %{_docdir}/%{libname}/COPYING

##### PRE/POST INSTALL SCRIPTS #####

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT


##### FILE LISTS FOR ALL BINARY PACKAGES #####

##### libgphoto-hotplug
%files hotplug
%defattr(-,root,root)
%{_sysconfdir}/udev/rules.d/90-libgphoto2.rules
%{_sysconfdir}/udev/agents.d/usb/usbcam
%{_datadir}/hal/fdi/information/20thirdparty/10-camera-libgphoto2.fdi

##### libgphoto2
%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*
# Here are only ".so" and no ".so.XXX" packages, so the ".so" have to be in
# the main package
%dir %{_libdir}/libgphoto2/*
%dir %{_libdir}/libgphoto2_port/*
%{_libdir}/libgphoto2/*/*.so
%{_libdir}/libgphoto2/*/*.la
%{_libdir}/libgphoto2_port/*/*.so
%{_libdir}/libgphoto2_port/*/*.la
%{_libdir}/udev/check-ptp-camera
%{_libdir}/udev/check-mtp-device

##### libgphoto-common
%files common -f %{name}.lang
%defattr(-,root,root)
%{_datadir}/libgphoto2

##### libgphoto-devel
%files -n %{develname}
%defattr(-,root,root)
%{_bindir}/*
%{_includedir}/gphoto2
%{_libdir}/*.la
%{_libdir}/*.so

%{_libdir}/pkgconfig/*
%{_mandir}/man3/*

%docdir %{_docdir}/%{libname}
%{_docdir}/%{libname}

%doc ABOUT-NLS ChangeLog HACKING MAINTAINERS TESTERS


%changelog
* Tue Nov 20 2007 Frederic Crozat <fcrozat@mandriva.com> 2.4.0-4mdv2008.0
+ Revision: 110738
- Patch11 (SVN): fix communication with Canon cameras in normal mode (Mdv bug 35642)

* Fri Aug 03 2007 Adam Williamson <awilliamson@mandriva.com> 2.4.0-3mdv2008.0
+ Revision: 58685
- fix bug #22017: since it basically involves dropping the entire upstream file, turn our patch2 into a source and just install it

* Fri Aug 03 2007 Adam Williamson <awilliamson@mandriva.com> 2.4.0-2mdv2008.0
+ Revision: 58680
- fix group for devel package (#28142)

* Fri Aug 03 2007 Adam Williamson <awilliamson@mandriva.com> 2.4.0-1mdv2008.0
+ Revision: 58513
- fix file list again
- actually we need to specify docdir or else it doesn't get lib64-ified
- drop static headers from file list as they're not generated
- generate HAL FDI file, with a little help from Fedora
- use new upstream method of generating udev rules, with a little help from Debian
- no need to specify docdir any more, default matches our new policy
- drop DCANON_EXPERIMENTAL_20D from cflags as it's now default upstream
- drop unnecessary calls to autotools
- new devel policy
- drop unneeded buildrequires on autotools
- drop already unapplied patches:
  * 20 through 36: merged upstream
  * 37: breaks build if re-applied
  * 38: no longer needed
- rediff patch10
- use Fedora licensing policy (licensing on this package is very complex)
- spec clean
- new release 2.4.0


* Sat Dec 30 2006 Pascal Terjan <pterjan@mandriva.org> 2.3.1-1mdv2007.0
+ Revision: 102789
- list new /lib/udev/check-ptp-camera
- 2.3.1
- New release
- Requires libusb-devel, needed by libgphoto2_port.pc

* Tue Dec 05 2006 Jérôme Soyer <saispo@mandriva.org> 2.3.0-1mdv2007.1
+ Revision: 91301
- New release 2.3.0

* Tue Dec 05 2006 Jérôme Soyer <saispo@mandriva.org> 2.2.1-9mdv2007.1
+ Revision: 91065
- Import libgphoto

* Thu Aug 31 2006 Frederic Crozat <fcrozat@mandriva.com> 2.2.1-9mdv2007.0
- Move plugins .la files to main package, it is required by digikam (Mdv bug #22797)

* Wed Aug 30 2006 Frederic Crozat <fcrozat@mandriva.com> 2.2.1-8mdv2007.0
- Update patch37, fix crash in Mdv bug #24405 (don't close shared connection)

* Wed Aug 30 2006 Till Kamppeter <till@mandriva.com> 2.2.1-7mdv2007.0
- Moved translations into libgphoto-common package.

* Thu Aug 10 2006 Frederic Crozat <fcrozat@mandriva.com> 2.2.1-6mdv2007.0
- Patch38: don't use dbus deprecated api (Mdv bug #24154)

* Wed Aug 09 2006 Till Kamppeter <till@mandriva.com> 2.2.1-5mdv2007.0
- Rebuilt again to adapt to API changes in DBUS.

* Wed Aug 02 2006 Frederic Crozat <fcrozat@mandriva.com> 2.2.1-4mdv2007.0
- Patch37: allow bootstrapping package
- Rebuild with latest dbus

* Tue Jul 11 2006 Till Kamppeter <till@mandriva.com> 2.2.1-3mdv2007.0
- Moved unversioned/platform-independent files out of the libgphoto2 package.

* Mon Jul 03 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.2.1-2mdv2007.0
- fix buildrequires
- fix macro-in-%%changelog
- fix prereq-use

* Sat Jul 01 2006 Till Kamppeter <till@mandriva.com> 2.2.1-1mdv2007.0
- Updated to GPhoto2 2.2.1.
- Added remote capture on Canon EOS 5D and other DIGIC II Canon DSLRs
  (patches 20-22).
- Uncompressed patches.

* Wed May 17 2006 Till Kamppeter <till@mandriva.com> 2.1.99-2mdk
- Fixes for building on 64-bit.

* Fri May 12 2006 Till Kamppeter <till@mandriva.com> 2.1.99-1mdk
- Updated to GPhoto2 2.1.99 (Preview of 2.2.x).
- Introduced %%mkrel.

* Thu Dec 29 2005 Frederic Crozat <fcrozat@mandriva.com> 2.1.6-11mdk
- Fix udev rules to remove .desktop file when device are unplugged

* Tue Dec 27 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-10mdk
- update Patch2 to make device removal possible with udev

* Thu Oct 27 2005 Till Kamppeter <till@mandriva.com> 2.1.6-8mdk
- Activated experimental support for the Canon EOS 20D in Canon (not PTP)
  mode.

* Thu Sep 08 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.1.6-8mdk
- lib64 fixes

* Mon Sep 05 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-7mdk
- rebuild for new udev_import_usermap

* Sat Sep 03 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-6mdk
- libgphoto-hotplug: require udev instead of hotplug

* Sat Sep 03 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-5mdk
- fix BuildRequires: udev_import_usermap is now in udev-tools

* Sun Aug 28 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-4mdk
- don't try to load the inexistent "usbcam" module in udev
- move usbcam script to /etc/udev/agents.d/usb/usbcam
- remove hotplug usermaps

* Fri Aug 26 2005 Olivier Blin <oblin@mandriva.com> 2.1.6-3mdk
- convert usermaps to udev rules

* Thu Aug 18 2005 Frederic Lepied <flepied@mandriva.com> 2.1.6-2mdk
- remove signature of Pentax Optio 450

* Tue Jun 28 2005 Till Kamppeter <till@mandrakesoft.com> 2.1.6-1mdk
- Updated to GPhoto2 2.1.6 (Bug fixes, support for newest camera models).
- Removed patch 1 (fixed upstream).

* Wed Mar 16 2005 Till Kamppeter <till@mandrakesoft.com> 2.1.5-2mdk
- Removed "Requires: libgphoto-hotplug" from the libgphoto2 package
  (bug 14416).
- Let libgphoto2 package own the /usr/lib/gphoto2_port and
  /usr/lib/gphoto2_port/0.5.1 directories (bug 14422).
- Let libgphoto2 package also own the /usr/lib/gphoto2 and
  /usr/lib/gphoto2/2.1.5 directories.
- Added multiarch stuff

* Thu Dec 16 2004 Till Kamppeter <till@mandrakesoft.com> 2.1.5-1mdk
- Updated to GPhoto2 2.1.5.

* Sat Nov 27 2004 Till Kamppeter <till@mandrakesoft.com> 2.1.5-0.rc1.1mdk
- Updated to GPhoto2 2.1.5rc1.

* Fri Oct 01 2004 Giuseppe Ghibò <ghibo@mandrakesoft.com> 2.1.4-3mdk
- Added signature so to recognize Canon IXUS 430.

* Tue Feb 10 2004 Pascal Terjan <pterjan@mandrake.org> 2.1.4-2mdk
- Patch from CVS to fix large file transfers from Canon cameras

* Fri Jan 23 2004 Till Kamppeter <till@mandrakesoft.com> 2.1.4-1mdk
- Updated to GPhoto2 2.1.4.

* Wed Jan 14 2004 Till Kamppeter <till@mandrakesoft.com> 2.1.4-0.pre1.1mdk
- Updated to GPhoto2 2.1.4pre1.

